#ifndef _WINIOCTLSAS_H_
#define _WINIOCTLSAS_H_

#include "commdef.h"
#include "if.h"

#include <iostream>
#include <tchar.h>

#include <wtypes.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <winioctl.h>

class ARCLIB_API WinIoctlSASInterface : public ArcInterface
{
	friend class CArclib;
public:     
	WinIoctlSASInterface();    
	~WinIoctlSASInterface();
	bool init(const int nScsiPort);
	int send(sIF_CMD_BLOCK *ifData);   
	int recv(sIF_CMD_BLOCK *ifData);       
	int syncSend(sIF_CMD_BLOCK *ifData);
	int	getMTU();
	void *getDeviceHandle();
	void requirelock();
	void releaselock();

private:
	BOOL ClearReadBuffer();
	BOOL ClearWriteBuffer();
	BOOL ClearReadWriteBuffer();
	HANDLE  m_hScsi;
	HANDLE  m_hSyncIm;
	PSECURITY_DESCRIPTOR    pSD;    
};

#endif

